DROP TABLE IF EXISTS `%TABLE_PREFIX%redactor_profiles`;

CREATE TABLE IF NOT EXISTS `%TABLE_PREFIX%redactor_profiles` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `lang` varchar(10) NOT NULL default '',
  `configuration` text NOT NULL default '',
  `ptype` tinyint(4) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

--
--
--

INSERT INTO `%TABLE_PREFIX%redactor_profiles` VALUES(1, 'css', 'CSS fuer den Redactor', '', '/* ----------------------- */\r\n/* Redactor specific rules */\r\n/* ----------------------- */\r\n\r\n/*\r\nHier koennen die CSS-Formatierungen aus dem Frontend-CSS eingefuegt werden\r\ndamit im Backend im Editor z.B. schon die korrekten Farben angezeigt werden\r\n*/\r\n\r\n.redactor_editor h1, h2, h3, h4 {\r\n	color: #14568a !important;\r\n}\r\n.redactor_editor a {\r\n	color: #14568a !important;\r\n}\r\n\r\n/*\r\nWYM-Modus\r\n*/\r\n\r\n.redactor_editor.redactor_editor_wym {\r\n	padding: 10px 7px 0 7px !important;\r\n	background: #f6f6f6 !important;\r\n}\r\n.redactor_editor_wym div,\r\n.redactor_editor_wym p,\r\n.redactor_editor_wym ul,\r\n.redactor_editor_wym ol,\r\n.redactor_editor_wym table,\r\n.redactor_editor_wym dl,\r\n.redactor_editor_wym pre,\r\n.redactor_editor_wym h1,\r\n.redactor_editor_wym h2,\r\n.redactor_editor_wym h3,\r\n.redactor_editor_wym h4,\r\n.redactor_editor_wym h5,\r\n.redactor_editor_wym h6,\r\n.redactor_editor_wym blockquote {\r\n	margin: 0 0 5px 0;\r\n	padding: 10px !important;\r\n	border: 1px solid #e4e4e4 !important;\r\n	background-color: #fff !important;\r\n}\r\n.redactor_editor_wym div {\r\n	border: 1px dotted #aaa !important;\r\n}\r\n.redactor_editor_wym pre {\r\n	border: 2px dashed #e4e4e4 !important;\r\n	background-color: #f8f8f8 !important;\r\n}\r\n.redactor_editor_wym ul,\r\n.redactor_editor_wym ol {\r\n	padding-left: 2em !important;\r\n}\r\n.redactor_editor_wym ul li ul,\r\n.redactor_editor_wym ul li ol,\r\n.redactor_editor_wym ol li ol,\r\n.redactor_editor_wym ol li ul {\r\n	border: none !important;\r\n}', 1);
INSERT INTO `%TABLE_PREFIX%redactor_profiles` VALUES(2, 'default', 'Standard Redactor-Konfiguration', 'de', '\r\nplugins: [''fullscreen''],\r\n\r\nbuttons: [\r\n	''html'', ''|'',\r\n	''formatting'', ''|'',\r\n	''bold'', ''italic'', ''deleted'', ''underline'', ''|'',\r\n	''alignment'', ''|'',\r\n	''unorderedlist'', ''orderedlist'', ''outdent'', ''indent'', ''|'',\r\n	''rex_link'', ''rex_linkmap'', ''rex_unlink'', ''rex_image'', ''rex_media'', ''horizontalrule'', ''|''\r\n	],\r\n\r\nfocus: false,\r\nautoresize: false,\r\ncleanup: true,\r\nconvertLinks: false,\r\nfixedBox: true,\r\nwym: false,\r\n\r\nrex_linktitle: true,  // title-Attribut bei REDAXO-Links ausgeben (Artikelname)\r\nrex_mediatitle: true, // title-Attribut bei Bildern ausgeben (Titel aus Medienpool)\r\nrex_filetitle: true,  // title-Attribut bei Dateilinks ausgeben (Titel aus Metadaten)', 0);
INSERT INTO `%TABLE_PREFIX%redactor_profiles` VALUES(3, 'full', 'Redactor-Konfiguration mit allen Funktionen', 'en', '\r\nplugins: [''fullscreen'', ''clips'', ''fontfamily'', ''fontsize'', ''textdirection''],\r\n\r\nbuttons:[\r\n	''html'', ''|'',\r\n	''formatting'', ''|'',\r\n	''bold'', ''italic'', ''deleted'', ''underline'', ''|'',\r\n	''alignment'', ''fontcolor'', ''backcolor'', ''|'',\r\n	''unorderedlist'', ''orderedlist'', ''outdent'', ''indent'', ''|'',\r\n	''rex_link'', ''rex_linkmap'', ''rex_unlink'', ''rex_image'', ''rex_media'', ''video'', ''table'', ''horizontalrule'', ''|''\r\n	],\r\n	\r\nfocus: false,\r\nautoresize: false,\r\ncleanup: true,\r\nconvertLinks: false,\r\nfixedBox: true,\r\nwym: false,\r\n\r\ncolors:[\r\n	''#ffffff'', ''#000000'', ''#eeece1'', ''#1f497d'', ''#4f81bd'', ''#c0504d'', ''#9bbb59'', ''#8064a2'', ''#4bacc6'', ''#f79646'', ''#ffff00'',\r\n	''#f2f2f2'', ''#7f7f7f'', ''#ddd9c3'', ''#c6d9f0'', ''#dbe5f1'', ''#f2dcdb'', ''#ebf1dd'', ''#e5e0ec'', ''#dbeef3'', ''#fdeada'', ''#fff2ca'',\r\n	''#d8d8d8'', ''#595959'', ''#c4bd97'', ''#8db3e2'', ''#b8cce4'', ''#e5b9b7'', ''#d7e3bc'', ''#ccc1d9'', ''#b7dde8'', ''#fbd5b5'', ''#ffe694'',\r\n	''#bfbfbf'', ''#3f3f3f'', ''#938953'', ''#548dd4'', ''#95b3d7'', ''#d99694'', ''#c3d69b'', ''#b2a2c7'', ''#b7dde8'', ''#fac08f'', ''#f2c314'',\r\n	''#a5a5a5'', ''#262626'', ''#494429'', ''#17365d'', ''#366092'', ''#953734'', ''#76923c'', ''#5f497a'', ''#92cddc'', ''#e36c09'', ''#c09100'',\r\n	''#7f7f7f'', ''#0c0c0c'', ''#1d1b10'', ''#0f243e'', ''#244061'', ''#632423'', ''#4f6128'', ''#3f3151'', ''#31859b'', ''#974806'', ''#7f6000''\r\n	],\r\n\r\nrex_linktitle: true,  // title-Attribut bei REDAXO-Links ausgeben (Artikelname)\r\nrex_mediatitle: true, // title-Attribut bei Bildern ausgeben (Titel aus Medienpool)\r\nrex_filetitle: true,  // title-Attribut bei Dateilinks ausgeben (Titel aus Metadaten)', 0);
INSERT INTO `%TABLE_PREFIX%redactor_profiles` VALUES(4, 'js', 'JS fuer den Redactor', '', '/*\r\nHier sind eigene Functions moeglich ...\r\n*/', 1);
INSERT INTO `%TABLE_PREFIX%redactor_profiles` VALUES(5, 'clips', 'Clips fuer den Redactor', '', '<!--\r\n\r\n	Clips Modal HTML\r\n	Achtung!!! Nur die <li>-Elemente anpassen !!!\r\n\r\n-->\r\n\r\n<div id="clipsmodal" style="display: none;">\r\n	<section>\r\n		<ul class="redactor_clips_box">\r\n\r\n\r\n			<li>\r\n				<a href="#" class="redactor_clip_link">Lorem ipsum</a>\r\n				<div class="redactor_clip" style="display: none;">\r\n					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\r\n				</div>\r\n			</li>\r\n\r\n\r\n			<li>\r\n				<a href="#" class="redactor_clip_link">Red label</a>\r\n				<div class="redactor_clip" style="display: none;">\r\n					<span class="label-red">Label</span>\r\n				</div>\r\n			</li>\r\n\r\n\r\n			</ul>\r\n	</section>\r\n	<footer>\r\n		<a href="#" class="redactor_modal_btn redactor_btn_modal_close">Close</a>\r\n	</footer>\r\n</div>', 1);
